From 9e5e78104d6c1ee30d71ae7f8066f3b6b68a7ea9 Mon Sep 17 00:00:00 2001
From: Pablo Rincon <pablo.rincon.crespo@gmail.com>
Date: Fri, 12 Mar 2010 19:22:01 +0100
Subject: [PATCH] Inline functions

---
 src/counters.c                   |  209 ----------------
 src/counters.h                   |  221 +++++++++++++++++-
 src/decode-icmpv4.c              |   52 ----
 src/decode-icmpv4.h              |   56 +++++-
 src/decode-icmpv6.c              |   71 ------
 src/decode-icmpv6.h              |   76 ++++++-
 src/decode-ipv4.c                |   56 +-----
 src/decode-ipv4.h                |   61 +++++-
 src/decode-tcp.c                 |  122 ----------
 src/decode-tcp.h                 |  129 ++++++++++-
 src/decode-udp.c                 |  120 ----------
 src/decode-udp.h                 |  127 ++++++++++-
 src/decode.c                     |   20 --
 src/decode.h                     |   28 ++-
 src/detect-classtype.c           |   80 +++----
 src/detect-classtype.h           |   31 +++
 src/detect-content.c             |   55 -----
 src/detect-content.h             |   59 +++++
 src/detect-dce-iface.c           |   94 +++-----
 src/detect-dce-iface.h           |   30 +++
 src/detect-dce-opnum.c           |   98 +++-----
 src/detect-dce-opnum.h           |   24 ++
 src/detect-engine-address.h      |    3 +-
 src/detect-engine-port.h         |    4 +
 src/detect-engine-sigorder.c     |  199 ----------------
 src/detect-engine-sigorder.h     |  224 ++++++++++++++++++
 src/detect-fast-pattern.c        |    5 -
 src/detect-fast-pattern.h        |    1 -
 src/detect-stream_size.c         |   44 ----
 src/detect-stream_size.h         |   47 ++++
 src/detect-uricontent.c          |  129 ----------
 src/detect-uricontent.h          |  132 +++++++++++
 src/detect.c                     |   54 -----
 src/detect.h                     |  100 +++++++--
 src/flow.c                       |   36 ---
 src/flow.h                       |   38 +++
 src/stream-tcp.c                 |   33 ---
 src/stream-tcp.h                 |   42 ++++
 src/suricata-common.h            |   31 +++
 src/suricata.h                   |    4 -
 src/tm-threads.c                 |  100 --------
 src/tm-threads.h                 |  113 +++++++++-
 src/util-byte.c                  |  335 --------------------------
 src/util-byte.h                  |  365 +++++++++++++++++++++++++++-
 src/util-classification-config.c |  203 +---------------
 src/util-classification-config.h |  197 +++++++++++++++
 src/util-debug-filters.c         |  289 +----------------------
 src/util-debug-filters.h         |  297 +++++++++++++++++++++++
 src/util-debug.c                 |  472 +------------------------------------
 src/util-debug.h                 |  485 +++++++++++++++++++++++++++++++++++++-
 src/util-mpm-b2g-cuda.c          |  326 -------------------------
 src/util-mpm-b2g-cuda.h          |  321 +++++++++++++++++++++++++
 src/util-mpm-b2g.c               |  305 ------------------------
 src/util-mpm-b2g.h               |  291 +++++++++++++++++++++++
 src/util-mpm-b3g.c               |  275 ---------------------
 src/util-mpm-b3g.h               |  285 ++++++++++++++++++++++
 src/util-mpm-wumanber.c          |  290 +----------------------
 src/util-mpm-wumanber.h          |  260 ++++++++++++++++++++
 src/util-mpm.c                   |  105 --------
 src/util-mpm.h                   |  111 +++++++++-
 src/util-radix-tree.c            |  106 +--------
 src/util-radix-tree.h            |  111 +++++++++
 src/util-spm-bm.c                |  234 ------------------
 src/util-spm-bm.h                |  254 +++++++++++++++++++-
 src/util-spm-bs.c                |   90 +-------
 src/util-spm-bs.h                |   96 ++++++++-
 src/util-spm-bs2bm.c             |  142 +-----------
 src/util-spm-bs2bm.h             |  151 ++++++++++++-
 src/util-spm.c                   |  108 +--------
 src/util-spm.h                   |   92 +++++++-
 70 files changed, 4961 insertions(+), 4793 deletions(-)

diff --git a/src/counters.c b/src/counters.c
index 5fb41f7..56e4df1 100644
--- a/src/counters.c
+++ b/src/counters.c
@@ -1278,215 +1278,6 @@ int SCPerfCounterDisplay(uint16_t id, SCPerfContext *pctx, int disp)
 }
 
 /**
- * \brief Increments the local counter
- *
- * \param id  Index of the counter in the counter array
- * \param pca Counter array that holds the local counters for this TM
- */
-inline void SCPerfCounterIncr(uint16_t id, SCPerfCounterArray *pca)
-{
-    if (pca == NULL) {
-        SCLogDebug("counterarray is NULL");
-        return;
-    }
-    if ((id < 1) || (id > pca->size)) {
-        SCLogDebug("counter doesn't exist");
-        return;
-    }
-
-    switch (pca->head[id].pc->value->type) {
-        case SC_PERF_TYPE_UINT64:
-            pca->head[id].ui64_cnt++;
-            break;
-        case SC_PERF_TYPE_DOUBLE:
-            pca->head[id].d_cnt++;
-            break;
-    }
-
-    if (pca->head[id].syncs == ULONG_MAX) {
-        pca->head[id].syncs = 0;
-        pca->head[id].wrapped_syncs++;
-    }
-    pca->head[id].syncs++;
-
-    return;
-}
-
-/**
- * \brief Adds a value of type uint64_t to the local counter.
- *
- * \param id  ID of the counter as set by the API
- * \param pca Counter array that holds the local counter for this TM
- * \param x   Value to add to this local counter
- */
-inline void SCPerfCounterAddUI64(uint16_t id, SCPerfCounterArray *pca, uint64_t x)
-{
-    if (!pca) {
-        SCLogDebug("counterarray is NULL");
-        return;
-    }
-    if ((id < 1) || (id > pca->size)) {
-        SCLogDebug("counter doesn't exist");
-        return;
-    }
-
-    switch (pca->head[id].pc->value->type) {
-        case SC_PERF_TYPE_UINT64:
-            pca->head[id].ui64_cnt += x;
-            break;
-        case SC_PERF_TYPE_DOUBLE:
-            pca->head[id].d_cnt += x;
-            break;
-    }
-
-    if (pca->head[id].syncs == ULONG_MAX) {
-        pca->head[id].syncs = 0;
-        pca->head[id].wrapped_syncs++;
-    }
-    pca->head[id].syncs++;
-
-    return;
-}
-
-/**
- * \brief Adds a value of type double to the local counter
- *
- * \param id  ID of the counter as set by the API
- * \param pca Counter array that holds the local counter for this TM
- * \param x   Value to add to this local counter
- */
-inline void SCPerfCounterAddDouble(uint16_t id, SCPerfCounterArray *pca, double x)
-{
-    if (!pca) {
-        SCLogDebug("counterarray is NULL");
-        return;
-    }
-    if ((id < 1) || (id > pca->size)) {
-        SCLogDebug("counter doesn't exist");
-        return;
-    }
-
-    /* incase you are trying to add a double to a counter of type SC_PERF_TYPE_UINT64
-     * it will be truncated */
-    switch (pca->head[id].pc->value->type) {
-        case SC_PERF_TYPE_UINT64:
-            pca->head[id].ui64_cnt += x;
-            break;
-        case SC_PERF_TYPE_DOUBLE:
-            pca->head[id].d_cnt += x;
-            break;
-    }
-
-    if (pca->head[id].syncs == ULONG_MAX) {
-        pca->head[id].syncs = 0;
-        pca->head[id].wrapped_syncs++;
-    }
-    pca->head[id].syncs++;
-
-    return;
-}
-
-/**
- * \brief Sets a value of type double to the local counter
- *
- * \param id  Index of the local counter in the counter array
- * \param pca Pointer to the SCPerfCounterArray
- * \param x   The value to set for the counter
- */
-inline void SCPerfCounterSetUI64(uint16_t id, SCPerfCounterArray *pca,
-                                 uint64_t x)
-{
-    if (!pca) {
-        SCLogDebug("counterarray is NULL");
-        return;
-    }
-
-    if ((id < 1) || (id > pca->size)) {
-        SCLogDebug("counter doesn't exist");
-        return;
-    }
-
-    switch (pca->head[id].pc->value->type) {
-        case SC_PERF_TYPE_UINT64:
-            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
-                 (x > pca->head[id].ui64_cnt)) {
-                pca->head[id].ui64_cnt = x;
-            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
-                pca->head[id].ui64_cnt = x;
-            }
-
-            break;
-        case SC_PERF_TYPE_DOUBLE:
-            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
-                 (x > pca->head[id].d_cnt)) {
-                pca->head[id].d_cnt = x;
-            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
-                pca->head[id].d_cnt = x;
-            }
-
-            break;
-    }
-
-    if (pca->head[id].syncs == ULONG_MAX) {
-        pca->head[id].syncs = 0;
-        pca->head[id].wrapped_syncs++;
-    }
-    pca->head[id].syncs++;
-
-    return;
-}
-
-/**
- * \brief Sets a local counter to an arg of type double
- *
- * \param id  Index of the local counter in the counter array
- * \param pca Pointer to the SCPerfCounterArray
- * \param x   The value to set for the counter
- */
-inline void SCPerfCounterSetDouble(uint16_t id, SCPerfCounterArray *pca,
-                                   double x)
-{
-    if (!pca) {
-        SCLogDebug("counterarray is NULL");
-        return;
-    }
-
-    if ((id < 1) || (id > pca->size)) {
-        SCLogDebug("counter doesn't exist");
-        return;
-    }
-
-    switch (pca->head[id].pc->value->type) {
-        case SC_PERF_TYPE_UINT64:
-            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
-                 (x > pca->head[id].ui64_cnt)) {
-                pca->head[id].ui64_cnt = x;
-            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
-                pca->head[id].ui64_cnt = x;
-            }
-
-            break;
-        case SC_PERF_TYPE_DOUBLE:
-            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
-                 (x > pca->head[id].d_cnt)) {
-                pca->head[id].d_cnt = x;
-            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
-                pca->head[id].d_cnt = x;
-            }
-
-            break;
-    }
-
-    if (pca->head[id].syncs == ULONG_MAX) {
-        pca->head[id].syncs = 0;
-        pca->head[id].wrapped_syncs++;
-    }
-    pca->head[id].syncs++;
-
-    return;
-}
-
-/**
  * \brief Syncs the counter array with the global counter variables
  *
  * \param pca      Pointer to the SCPerfCounterArray
diff --git a/src/counters.h b/src/counters.h
index ee6a908..e95dbf1 100644
--- a/src/counters.h
+++ b/src/counters.h
@@ -221,13 +221,6 @@ SCPerfCounterArray *SCPerfGetCounterArrayRange(uint16_t, uint16_t, SCPerfContext
 SCPerfCounterArray * SCPerfGetAllCountersArray(SCPerfContext *);
 int SCPerfCounterDisplay(uint16_t, SCPerfContext *, int);
 
-/* functions used to update local counter values */
-inline void SCPerfCounterIncr(uint16_t, SCPerfCounterArray *);
-inline void SCPerfCounterAddUI64(uint16_t, SCPerfCounterArray *, uint64_t);
-inline void SCPerfCounterAddDouble(uint16_t, SCPerfCounterArray *, double);
-inline void SCPerfCounterSetUI64(uint16_t, SCPerfCounterArray *, uint64_t);
-inline void SCPerfCounterSetDouble(uint16_t, SCPerfCounterArray *, double);
-
 int SCPerfUpdateCounterArray(SCPerfCounterArray *, SCPerfContext *, int);
 
 void SCPerfOutputCounters(void);
@@ -239,4 +232,218 @@ void SCPerfReleasePCA(SCPerfCounterArray *);
 
 void SCPerfRegisterTests(void);
 
+/** --------- Inline functions --------- */
+
+/* functions used to update local counter values */
+
+/**
+ * \brief Sets a local counter to an arg of type double
+ *
+ * \param id  Index of the local counter in the counter array
+ * \param pca Pointer to the SCPerfCounterArray
+ * \param x   The value to set for the counter
+ */
+static inline void SCPerfCounterSetDouble(uint16_t id, SCPerfCounterArray *pca,
+                                   double x)
+{
+    if (!pca) {
+        SCLogDebug("counterarray is NULL");
+        return;
+    }
+
+    if ((id < 1) || (id > pca->size)) {
+        SCLogDebug("counter doesn't exist");
+        return;
+    }
+
+    switch (pca->head[id].pc->value->type) {
+        case SC_PERF_TYPE_UINT64:
+            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
+                 (x > pca->head[id].ui64_cnt)) {
+                pca->head[id].ui64_cnt = x;
+            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
+                pca->head[id].ui64_cnt = x;
+            }
+
+            break;
+        case SC_PERF_TYPE_DOUBLE:
+            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
+                 (x > pca->head[id].d_cnt)) {
+                pca->head[id].d_cnt = x;
+            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
+                pca->head[id].d_cnt = x;
+            }
+
+            break;
+    }
+
+    if (pca->head[id].syncs == ULONG_MAX) {
+        pca->head[id].syncs = 0;
+        pca->head[id].wrapped_syncs++;
+    }
+    pca->head[id].syncs++;
+
+    return;
+}
+
+/**
+ * \brief Sets a value of type double to the local counter
+ *
+ * \param id  Index of the local counter in the counter array
+ * \param pca Pointer to the SCPerfCounterArray
+ * \param x   The value to set for the counter
+ */
+static inline void SCPerfCounterSetUI64(uint16_t id, SCPerfCounterArray *pca,
+                                 uint64_t x)
+{
+    if (!pca) {
+        SCLogDebug("counterarray is NULL");
+        return;
+    }
+
+    if ((id < 1) || (id > pca->size)) {
+        SCLogDebug("counter doesn't exist");
+        return;
+    }
+
+    switch (pca->head[id].pc->value->type) {
+        case SC_PERF_TYPE_UINT64:
+            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
+                 (x > pca->head[id].ui64_cnt)) {
+                pca->head[id].ui64_cnt = x;
+            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
+                pca->head[id].ui64_cnt = x;
+            }
+
+            break;
+        case SC_PERF_TYPE_DOUBLE:
+            if ( (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_MAXIMUM) &&
+                 (x > pca->head[id].d_cnt)) {
+                pca->head[id].d_cnt = x;
+            } else if (pca->head[id].pc->type_q->type & SC_PERF_TYPE_Q_NORMAL) {
+                pca->head[id].d_cnt = x;
+            }
+
+            break;
+    }
+
+    if (pca->head[id].syncs == ULONG_MAX) {
+        pca->head[id].syncs = 0;
+        pca->head[id].wrapped_syncs++;
+    }
+    pca->head[id].syncs++;
+
+    return;
+}
+
+/**
+ * \brief Adds a value of type double to the local counter
+ *
+ * \param id  ID of the counter as set by the API
+ * \param pca Counter array that holds the local counter for this TM
+ * \param x   Value to add to this local counter
+ */
+static inline void SCPerfCounterAddDouble(uint16_t id, SCPerfCounterArray *pca, double x)
+{
+    if (!pca) {
+        SCLogDebug("counterarray is NULL");
+        return;
+    }
+    if ((id < 1) || (id > pca->size)) {
+        SCLogDebug("counter doesn't exist");
+        return;
+    }
+
+    /* incase you are trying to add a double to a counter of type SC_PERF_TYPE_UINT64
+     * it will be truncated */
+    switch (pca->head[id].pc->value->type) {
+        case SC_PERF_TYPE_UINT64:
+            pca->head[id].ui64_cnt += x;
+            break;
+        case SC_PERF_TYPE_DOUBLE:
+            pca->head[id].d_cnt += x;
+            break;
+    }
+
+    if (pca->head[id].syncs == ULONG_MAX) {
+        pca->head[id].syncs = 0;
+        pca->head[id].wrapped_syncs++;
+    }
+    pca->head[id].syncs++;
+
+    return;
+}
+
+/**
+ * \brief Adds a value of type uint64_t to the local counter.
+ *
+ * \param id  ID of the counter as set by the API
+ * \param pca Counter array that holds the local counter for this TM
+ * \param x   Value to add to this local counter
+ */
+static inline void SCPerfCounterAddUI64(uint16_t id, SCPerfCounterArray *pca, uint64_t x)
+{
+    if (!pca) {
+        SCLogDebug("counterarray is NULL");
+        return;
+    }
+    if ((id < 1) || (id > pca->size)) {
+        SCLogDebug("counter doesn't exist");
+        return;
+    }
+
+    switch (pca->head[id].pc->value->type) {
+        case SC_PERF_TYPE_UINT64:
+            pca->head[id].ui64_cnt += x;
+            break;
+        case SC_PERF_TYPE_DOUBLE:
+            pca->head[id].d_cnt += x;
+            break;
+    }
+
+    if (pca->head[id].syncs == ULONG_MAX) {
+        pca->head[id].syncs = 0;
+        pca->head[id].wrapped_syncs++;
+    }
+    pca->head[id].syncs++;
+
+    return;
+}
+
+/**
+ * \brief Increments the local counter
+ *
+ * \param id  Index of the counter in the counter array
+ * \param pca Counter array that holds the local counters for this TM
+ */
+static inline void SCPerfCounterIncr(uint16_t id, SCPerfCounterArray *pca)
+{
+    if (pca == NULL) {
+        SCLogDebug("counterarray is NULL");
+        return;
+    }
+    if ((id < 1) || (id > pca->size)) {
+        SCLogDebug("counter doesn't exist");
+        return;
+    }
+
+    switch (pca->head[id].pc->value->type) {
+        case SC_PERF_TYPE_UINT64:
+            pca->head[id].ui64_cnt++;
+            break;
+        case SC_PERF_TYPE_DOUBLE:
+            pca->head[id].d_cnt++;
+            break;
+    }
+
+    if (pca->head[id].syncs == ULONG_MAX) {
+        pca->head[id].syncs = 0;
+        pca->head[id].wrapped_syncs++;
+    }
+    pca->head[id].syncs++;
+
+    return;
+}
+
+
 #endif /* __COUNTERS_H__ */
diff --git a/src/decode-icmpv4.c b/src/decode-icmpv4.c
index 43c1e80..07c53db 100644
--- a/src/decode-icmpv4.c
+++ b/src/decode-icmpv4.c
@@ -13,58 +13,6 @@
 #include "util-debug.h"
 
 /**
- * \brief Calculates the checksum for the ICMP packet
- *
- * \param pkt  Pointer to the start of the ICMP packet
- * \param hlen Total length of the ICMP packet(header + payload)
- *
- * \retval csum Checksum for the ICMP packet
- */
-inline uint16_t ICMPV4CalculateChecksum(uint16_t *pkt, uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = pkt[0];
-
-    tlen -= 4;
-    pkt += 2;
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        tlen -= 2;
-        pkt += 1;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
-/**
  * Note, this is the IP header, plus a bit of the original packet, not the whole thing!
  */
 void DecodePartialIPV4( Packet* p, uint8_t* partial_packet, uint16_t len )
diff --git a/src/decode-icmpv4.h b/src/decode-icmpv4.h
index a864aa6..7d72a73 100644
--- a/src/decode-icmpv4.h
+++ b/src/decode-icmpv4.h
@@ -222,9 +222,63 @@ typedef struct ICMPV4Cache_ {
     int32_t comp_csum;
 } ICMPV4Cache;
 
-inline uint16_t ICMPV4CalculateChecksum(uint16_t *, uint16_t);
+static inline uint16_t ICMPV4CalculateChecksum(uint16_t *, uint16_t);
 
 void DecodeICMPV4RegisterTests(void);
 
+/** ------- inline functions ----- */
+/**
+ * \brief Calculates the checksum for the ICMP packet
+ *
+ * \param pkt  Pointer to the start of the ICMP packet
+ * \param hlen Total length of the ICMP packet(header + payload)
+ *
+ * \retval csum Checksum for the ICMP packet
+ */
+static inline uint16_t ICMPV4CalculateChecksum(uint16_t *pkt, uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = pkt[0];
+
+    tlen -= 4;
+    pkt += 2;
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        tlen -= 2;
+        pkt += 1;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+
 #endif /* __DECODE_ICMPV4_H__ */
 
diff --git a/src/decode-icmpv6.c b/src/decode-icmpv6.c
index 36512ae..8164f78 100644
--- a/src/decode-icmpv6.c
+++ b/src/decode-icmpv6.c
@@ -10,77 +10,6 @@
 #include "flow.h"
 #include "util-debug.h"
 
-/**
- * \brief Calculates the checksum for the ICMPV6 packet
- *
- * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
- *             part of the psuedoheader for computing the checksum
- * \param pkt  Pointer to the start of the ICMPV6 packet
- * \param tlen Total length of the ICMPV6 packet(header + payload)
- *
- * \retval csum Checksum for the ICMPV6 packet
- */
-inline uint16_t ICMPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
-                                        uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = shdr[0];
-
-    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
-        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
-        shdr[13] + shdr[14] + shdr[15] + htons(58 + tlen);
-
-    csum += pkt[0];
-
-    tlen -= 4;
-    pkt += 2;
-
-    while (tlen >= 64) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15] + pkt[16] + pkt[17] + pkt[18] + pkt[19] +
-            pkt[20] + pkt[21] + pkt[22] + pkt[23] + pkt[24] + pkt[25] +
-            pkt[26] + pkt[27] + pkt[28] + pkt[29] + pkt[30] + pkt[31];
-        tlen -= 64;
-        pkt += 32;
-    }
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        tlen -= 2;
-        pkt += 1;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
 
 /**
  * \brief Get variables and do some checks of the embedded IPV6 packet
diff --git a/src/decode-icmpv6.h b/src/decode-icmpv6.h
index f453742..f287b18 100644
--- a/src/decode-icmpv6.h
+++ b/src/decode-icmpv6.h
@@ -139,8 +139,82 @@ typedef struct ICMPV6Vars_ {
 
 } ICMPV6Vars;
 
-inline uint16_t ICMPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
+static inline uint16_t ICMPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
 void DecodeICMPV6RegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Calculates the checksum for the ICMPV6 packet
+ *
+ * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
+ *             part of the psuedoheader for computing the checksum
+ * \param pkt  Pointer to the start of the ICMPV6 packet
+ * \param tlen Total length of the ICMPV6 packet(header + payload)
+ *
+ * \retval csum Checksum for the ICMPV6 packet
+ */
+static inline uint16_t ICMPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
+                                        uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = shdr[0];
+
+    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
+        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
+        shdr[13] + shdr[14] + shdr[15] + htons(58 + tlen);
+
+    csum += pkt[0];
+
+    tlen -= 4;
+    pkt += 2;
+
+    while (tlen >= 64) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15] + pkt[16] + pkt[17] + pkt[18] + pkt[19] +
+            pkt[20] + pkt[21] + pkt[22] + pkt[23] + pkt[24] + pkt[25] +
+            pkt[26] + pkt[27] + pkt[28] + pkt[29] + pkt[30] + pkt[31];
+        tlen -= 64;
+        pkt += 32;
+    }
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        tlen -= 2;
+        pkt += 1;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+
 #endif /* __DECODE_ICMPV6_H__ */
 
diff --git a/src/decode-ipv4.c b/src/decode-ipv4.c
index f08c7f6..c716d97 100644
--- a/src/decode-ipv4.c
+++ b/src/decode-ipv4.c
@@ -13,62 +13,8 @@
 #include "util-unittest.h"
 #include "util-debug.h"
 
-/**
- * \brief Calculates the checksum for the IP packet
- *
- * \param pkt  Pointer to the start of the IP packet
- * \param hlen Length of the IP header
- *
- * \retval csum Checksum for the IP packet
- */
-inline uint16_t IPV4CalculateChecksum(uint16_t *pkt, uint16_t hlen)
-{
-    uint32_t csum = pkt[0];
+static uint16_t IPV4CalculateChecksum(uint16_t *pkt, uint16_t hlen);
 
-    csum += pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[6] + pkt[7] + pkt[8] +
-        pkt[9];
-
-    hlen -= 20;
-    pkt += 10;
-
-    if (hlen == 0) {
-        ;
-    }
-    if (hlen == 4)
-        csum += pkt[0] + pkt[1];
-    else if (hlen == 8)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-    else if (hlen == 12)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5];
-    else if (hlen == 16)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7];
-    else if (hlen == 20)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9];
-    else if (hlen == 24)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11];
-    else if (hlen == 28)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13];
-    else if (hlen == 32)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-    if (hlen == 36)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15] + pkt[16] + pkt[17];
-    if (hlen == 40)
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15] + pkt[16] + pkt[17] + pkt[18] + pkt[19];
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
 
 /* Generic validation
  *
diff --git a/src/decode-ipv4.h b/src/decode-ipv4.h
index d72b036..8fda864 100644
--- a/src/decode-ipv4.h
+++ b/src/decode-ipv4.h
@@ -186,8 +186,67 @@ typedef struct IPV4Vars_
     IPV4Opt *o_rtralt;
 } IPV4Vars;
 
-inline uint16_t IPV4CalculateChecksum(uint16_t *, uint16_t);
 void DecodeIPV4RegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Calculates the checksum for the IP packet
+ *
+ * \param pkt  Pointer to the start of the IP packet
+ * \param hlen Length of the IP header
+ *
+ * \retval csum Checksum for the IP packet
+ */
+static inline uint16_t IPV4CalculateChecksum(uint16_t *pkt, uint16_t hlen)
+{
+    uint32_t csum = pkt[0];
+
+    csum += pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[6] + pkt[7] + pkt[8] +
+        pkt[9];
+
+    hlen -= 20;
+    pkt += 10;
+
+    if (hlen == 0) {
+        ;
+    }
+    if (hlen == 4)
+        csum += pkt[0] + pkt[1];
+    else if (hlen == 8)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+    else if (hlen == 12)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5];
+    else if (hlen == 16)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7];
+    else if (hlen == 20)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9];
+    else if (hlen == 24)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11];
+    else if (hlen == 28)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13];
+    else if (hlen == 32)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+    if (hlen == 36)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15] + pkt[16] + pkt[17];
+    if (hlen == 40)
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15] + pkt[16] + pkt[17] + pkt[18] + pkt[19];
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+
 #endif /* __DECODE_IPV4_H__ */
 
